// $Id: spade.js,v 1.3 2003/02/12 14:26:10 cdn Exp $

function spadeMenuCommand(e) {
  var urlBar = document.getElementById("urlbar");
  if(e.target.id == "spade-clear-url") {
    // Clear Location
    urlBar.value = "";
    urlBar.focus();
  } else {
    // load url
    var uriToLoad = e.target.getAttribute("label");
    urlBar.value = uriToLoad;
    loadURI(uriToLoad);
  }
}


function spadeBuildMenu() {
  var url = document.getElementById("urlbar").value;
  var spadeMenu = document.getElementById("spade-menu");

  var reChrome = /^chrome:\/\//i;
  
  if(reChrome.test(url))
  {
    url = '';
  }
  
  // clear the spade menu
  var children = spadeMenu.childNodes;
  for(var i = 0; i < children.length; i++)
    spadeMenu.removeChild(children[i]);

  // burrow down through directory structure
  if(url.length > 0) {
   // spadeAddMenuSeparator(spadeMenu);
    var myRegExp = new RegExp("(.*[^/]/)[^/]+/?$");
    var tmpUrl = url;
    while(tmpUrl!=null) {
      url = tmpUrl;
      spadeAddMenuItem(spadeMenu, url);
      var match = url.match(myRegExp);
      tmpUrl = match==null ? null : match[1];
    }
  }

  // if http offer ftp alternatives
  var reHttp = /^https?:/i;
  var altUrl=''; // ftp for http sites and vice versa
  var altUrl2='';
  
  if(reHttp.test(url)) {
    altUrl = url.replace(/^http:\/\//i, "ftp://");
    altUrl = altUrl.replace(reHttp, "ftp:");
    altUrl2 = url.replace(/^http:\/\/www/i, "ftp://ftp");
    altUrl2 = altUrl2.replace(reHttp, "ftp:");
/*  } else if(reHttps.test(url)) {
    altUrl = url.replace(/^https:\/\//i, "ftp://");
    altUrl = altUrl.replace(reHttps, "ftp:");
    altUrl2 = url.replace(/^https:\/\/www/i, "ftp://ftp");
    altUrl2 = altUrl2.replace(reHttps, "ftp:");*/
  } else {
    altUrl = url.replace(/^ftp:\/\/ftp/i, "http://www");
    altUrl = altUrl.replace(/^ftp:\/\//i, "http://");
    altUrl2 = url.replace(/^ftp:\/\//i, "http://");
    altUrl2 = altUrl2.replace(/^ftp:/i, "http:");
  }
  if( altUrl2 != '')
  {
    spadeAddMenuSeparator(spadeMenu);
    spadeAddMenuItem(spadeMenu, altUrl);
  }
  
  if( altUrl2 != altUrl && altUrl2 != '' )
  {
    spadeAddMenuItem(spadeMenu, altUrl2);
  }

  var reHttps = /^https:/i;
  var reFtp = /^ftp:/i;
  var altUrl3='';
  var altUrl4='';
  // https for http sites and vice versa
  if(reHttp.test(url)) {
    altUrl3 = url.replace(/^http:\/\//i, "https://");
    altUrl3 = altUrl3.replace(reHttp, "https:");
  }
  if(reHttps.test(url)) {
    altUrl3 = url.replace(/^https:\/\//i, "http://");
    altUrl3 = altUrl3.replace(reHttps, "http:");
  }
  if(reFtp.test(url)) {
    altUrl3 = url.replace(/^ftp:\/\/ftp/i, "https://www");
    altUrl3 = altUrl3.replace(reFtp, "https:");
    altUrl4 = url.replace(/^ftp:\/\//i, "https://");
    altUrl4 = altUrl4.replace(reFtp, "https:");
  }
  
  if( altUrl3 != altUrl && altUrl3 != altUrl2 && altUrl3 != '' )
  {
    spadeAddMenuSeparator(spadeMenu);
    spadeAddMenuItem(spadeMenu, altUrl3);
  }

  if( altUrl4 != altUrl && altUrl4 != altUrl2 && altUrl4 != altUrl3 && altUrl4 != '')
  {
    spadeAddMenuItem(spadeMenu, altUrl4);
  }
  
  // climb up through subdomains !FUTURE

  // chop off protocol and save
  var reFtp = /^ftp:/i;
  var altProt;
  var altUri;

  if(reHttp.test(url)) {
   altUri = url.replace(/^http:\/\//i, "");
   altProt = "http://";
  }
  if(reHttps.test(url)) {
   altUri = url.replace(/^https:\/\//i, "");
   altProt = "https://";
  }
  if(reFtp.test(url)) {
   altUri = url.replace(/^ftp:\/\//i, "");
   altProt = "ftp://";
  }

  dump('protocol : ' + altProt + '\n');
  
  // work towards 2ld.tld from nld.n-1ld ... 3ld.2ld.tld
  // i.e. netscape.com from devedge.netscape.com [3ld.2ld.tld]
  //      nyphp.org from mozdev.mirrors.nyphp.org [4ld.3ld.2ld.tld]
  if(altUri.length > 0) {
    spadeAddMenuSeparator(spadeMenu);
   // dump('added separator for nld\n');
    
    // subdomain regex
    var myRegEx = /^[0-9a-z-]+\./i;
    var host_tld = /[0-9a-z-]+\.+[0-9a-z-]{2,5}/i;
    var tmpUri = altUri;
    
    var ij = 0
    while( host_tld.test(tmpUri) ) {
      url = tmpUri.replace(myRegEx, '');
      spadeAddMenuItem(spadeMenu, altProt + url);
      dump(altProt + url + '\n');
      tmpUri = url;
      ++ij;
    }
    
    if ( ij > 1 )
    {
      var children2 = spadeMenu.childNodes;
      var children2l = children2.length-1;
      
      // remove last item 'protocol://tld'
      spadeMenu.removeChild(children2[children2l]);
    }
  }
  
}


function spadeAddMenuSeparator(aParent) {
  var separator = document.createElement("menuseparator");
  aParent.appendChild(separator);
}

function spadeAddMenuItem(aParent, aLabel) {
  var menuitem = document.createElement("menuitem");
  menuitem.setAttribute("label", aLabel);
  aParent.appendChild(menuitem);
}
